import greenfoot.*;
import java.awt.Color;

public class julia extends Actor {

    final static int WIDTH = 400;
    final static int HEIGHT = 400;
    public Complex c =  new Complex(-0.8 ,0.156);

    double pixelSize;
    double yMin;
    double xMin;
    int iterations;
    GreenfootImage image;
    
    public static double real = -2.0 ;
    public static double imag = -2.0 ;

    private int mxawal = 0;
    private int myawal = 0;
    private int mxakhir = 0;
    private int myakhir = 0;
    
    private boolean dragkah = false;
        
    
    public julia() {
        this(-1.0, -1.0, 1, 255);

    }

    public julia(double xMin, double yMin, double pixelSize, int iterations) {
        this.pixelSize = pixelSize;
        this.yMin = yMin;
        this.xMin = xMin;
        this.iterations = iterations;
        this.image = new GreenfootImage(julia.WIDTH, julia.HEIGHT);
        this.drawJuliaImage();
        setImage(this.image);
    }

    public double getYMin() {
        return this.yMin;
    }

    public void setYMin(double min) {
        this.yMin = min;
        this.drawJuliaImage();
    }


    public void act() {
            
        if( (Greenfoot.mouseDragged(this)) && (dragkah == false) ) {
            MouseInfo mouse = Greenfoot.getMouseInfo();  
            if(mouse!=null){  
               mxawal = mouse.getX();  
               myawal = mouse.getY();  
               dragkah = true;
               //System.out.println("dragged");
            }
        }
        
        if( Greenfoot.mouseDragEnded(this) ) {
            MouseInfo mouse = Greenfoot.getMouseInfo();  
            if(mouse!=null){  
               mxakhir = mouse.getX();  
               myakhir = mouse.getY();  
               dragkah = false;
               updateRealImageRedraw();
               //System.out.println("mouse awal = " + mxawal + "," + myawal + " -- akhir = " + mxakhir + " , " + myakhir);
            }
        }
        
        
    }
    
    public void updateRealImageRedraw() {
        //System.out.println("updateRealImageRedraw");
        
        double deltax =  (mxakhir - mxawal);
        double deltay =  myakhir - myawal;
        
        if(deltax != 0)
            deltax = deltax/1000;
        if(deltay != 0)
            deltay = deltay/1000;
        
        redrawjulia(deltax, deltay);
    }
    
    public void setReal(double newvalue) {
        this.real = newvalue;
    }
    
    public void setImag(double newvalue) {
        this.imag = newvalue;
    }
    
    public double getReal() {
        return this.real ;
    }
    
    public double getImag() {
        return this.imag;
    }
    
    public void redrawjulia(double deltax, double deltay) {
        
        //System.out.println("redrawjulia = " + deltax + " , " + deltay);
        
        setReal(getReal() + deltax);
        setImag(getImag() + deltay);
        
        if (getReal() < -2.0 )
            setReal(-2.0);
        if (getImag() < -2.0)
            setImag(-2.0);
        
        if (getReal() > 2.0 )
            setReal(2.0);
        if (getImag() > 2.0)
            setImag(2.0);
            
        drawJuliaImage();
    }

    public void drawJuliaImage() {
        this.image.clear();
        
        c =  new Complex(real ,imag);

        for (int y = 0; y < julia.HEIGHT; y++) {

            //c = new Complex(this.xMin, c.getImaginaryPart());

            for (int x = 0; x < julia.WIDTH; x++) {

                double koordx = (( ((double)x) / ((double)julia.WIDTH)) * 4) - 2;
                double koordy = (( ((double)y) / ((double)julia.HEIGHT)) * 4) - 2;
                Complex koord = new Complex(koordx, koordy);

                int iterationsC = this.checkC(koord);
                Color warna = new Color(
                        255 - iterationsC ,255 - iterationsC  ,255 - iterationsC );
                this.image.setColorAt(x, y, warna);

            }
        }
    }

    private int checkC(Complex koor) {
        Complex zold = new Complex(koor);
        Complex znew = new Complex();

        int i;
        for (i = 0; i < this.iterations; i++) {

            znew = Complex.add(Complex.mult(zold, zold), c);
            if ( ( (znew.getRealPart() * znew.getRealPart()) + (znew.getImaginaryPart()
                    * znew.getImaginaryPart()) ) > 4) {
                return i;
            }
            zold = new Complex(znew);
        }
        return i;
    }

}
